module Srnggen
  # generic class for nodes of a grammar.
  #
  # Subclasses inherit from class Node. They include one of the modules in
  # Comb to specify the combinatorial construction to which they
  # correspond.
  class Node
    # parse a grammar
    def Node.parse xml, doc
      const_get(xml.name.capitalize).new xml, doc
    end

    attr_reader :doc, :oracle, :elems

    def elem x=1
      @elems[x-1]
    end

    def initialize xml, doc
      @xml, @doc, @oracle, @elems = xml, doc, 1, []
      xml.each_element {|e| @elems << Node.parse(e, doc)} if xml
    end

    def inspect
      "#{self.class}(#{@elems.join(",")})"
    end

    def to_s
      inspect
    end
  end
end
