module Srnggen
  class Res
    def initialize seq=[], att={}
      @seq, @att = seq, att
    end

    attr_reader :att, :seq

    def to_e name
      res = REXML::Element.new name
      @seq.each do |e|
        case e
        when REXML::Element
          res << e
        when String
          res.add_text e
        end
      end
      res.add_attributes @att
      res
    end

    def join r
      @att.update r.att
      @seq += r.seq
      self
    end

    def compact
      @seq = [ @seq.join(" ") ]
      self
    end

    def interleave r
      @att.update r.att
      res, pos = [], []
      s1, s2 = @seq.length, r.seq.length
      1.upto(s1+s2) {|i| pos << i}
      s1.times {pos.delete_at rand(pos.length)}
      1.upto(s1+s2) do |i|
        if pos.include? i
          res << r.seq.shift
        else
          res << @seq.shift
        end
      end
      @seq = res
      self
    end

    def to_s
      @seq.join("")
    end

    def element
      #TODO verify that there is only one element in @seq
      @seq.first
    end
  end
end
